﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CoreScanner;
using System.Xml.Linq;

namespace ScannerSDK_Guide_Example_01
{
    public partial class Form1 : Form
    {
        int startScanners = 0;
        string rawScan;
        string hexx;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timer1.Interval = 1000;
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (startScanners == 4) { timer1.Stop(); ConnectScanners(); }
            startScanners++;
        }

        private void ConnectScanners()
        {
            try
            {
                //Instantiate CoreScanner Class
                var cCoreScannerClass = new CCoreScannerClass();
                //Call Open API
                short[] scannerTypes = new short[1];//Scanner Types you are interested in
                scannerTypes[0] = 1; // 1 for all scanner types
                short numberOfScannerTypes = 1; // Size of the scannerTypes array
                int status; // Extended API return code
                cCoreScannerClass.Open(0, scannerTypes, numberOfScannerTypes, out status);
                // Subscribe for barcode events in cCoreScannerClass
                cCoreScannerClass.BarcodeEvent += new
                _ICoreScannerEvents_BarcodeEventEventHandler(OnBarcodeEvent);
                // Let's subscribe for events
                int opcode = 1001; // Method for Subscribe events
                string outXML; // XML Output
                string inXML = "<inArgs>" +
                "<cmdArgs>" +
                "<arg-int>1</arg-int>" + // Number of events you want to subscribe
                "<arg-int>1</arg-int>" + // Comma separated event IDs
                "</cmdArgs>" +
                "</inArgs>";
                cCoreScannerClass.ExecCommand(opcode, ref inXML, out outXML, out status);
                MessageBox.Show(outXML + '\n' + status);

                /*---- Attempting to execute a CLAIM_DEVICE command
                  cCoreScannerClass.ExecCommand(1500, String.Empty, out outXML, out status);
                  MessageBox.Show(outXML + '\n' + status);
                Above two lines return '300' for status in the messagebox ----*/
            }
            catch (Exception exp)
            {
                MessageBox.Show("Something wrong please check... " + exp.Message);
            }

        }

        void OnBarcodeEvent(short eventType, ref string pscanData)
        {
            string barcode = pscanData;
            rawScan = barcode;
            richTextBox1.Invoke((MethodInvoker)delegate { richTextBox1.Text = barcode; HexParse(); });
        }

        private void HexParse()
        {
            XDocument doc = XDocument.Parse(rawScan);
            var datalabels = doc.Descendants("datalabel");
            foreach (var datalabel in datalabels)
            {
                richTextBox2.Text = datalabel.Value + Environment.NewLine;
               
                    try
                    {
                        string ascii = string.Empty;
                        hexx = datalabel.Value.Replace("0x", "").Replace(" ", "");
                        for (int i = 0; i < hexx.Length; i += 2)
                        {
                            String hs = string.Empty;
                            hs = hexx.Substring(i, 2);
                            uint decval = System.Convert.ToUInt32(hs, 16);
                            char character = System.Convert.ToChar(decval);
                            ascii += character;
                        }


                        try
                        {
                            richTextBox2.AppendText('\n' + "----------------------------------------" + '\n' + ascii);
                        }
                        catch
                        {

                        }
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
            }
        }       
    }
}
